"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const TimePickerField_1 = require("@procyon/forms/components/fields/TimePickerField");
const constants_1 = require("../constants");
const CheckboxField_1 = require("./fields/CheckboxField");
const DatePickerField_1 = require("./fields/DatePickerField");
const RadioButtonField_1 = require("./fields/RadioButtonField");
const SelectBoxField_1 = require("./fields/SelectBoxField");
const TextField_1 = require("./fields/TextField");
function Field(props) {
    const _a = props, { component } = _a, other = __rest(_a, ["component"]);
    let render = null;
    switch (component) {
        case constants_1.FIELD_TYPE.TEXT_FIELD:
            render = react_1.default.createElement(TextField_1.TextField, Object.assign({}, other));
            break;
        case constants_1.FIELD_TYPE.CHECKBOX:
            render = react_1.default.createElement(CheckboxField_1.CheckboxField, Object.assign({}, other));
            break;
        case constants_1.FIELD_TYPE.RADIO_BUTTON:
            render = react_1.default.createElement(RadioButtonField_1.RadioButtonField, Object.assign({}, other));
            break;
        case constants_1.FIELD_TYPE.SELECT_BOX:
            render = react_1.default.createElement(SelectBoxField_1.SelectBoxField, Object.assign({}, other));
            break;
        case constants_1.FIELD_TYPE.DATE_PICKER:
            render = react_1.default.createElement(DatePickerField_1.DatePickerField, Object.assign({}, other));
            break;
        case constants_1.FIELD_TYPE.TIME_PICKER:
            render = react_1.default.createElement(TimePickerField_1.TimePickerField, Object.assign({}, other));
            break;
    }
    return react_1.default.createElement("div", { className: "form-field-container" }, render);
}
exports.default = Field;
