"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectBoxField = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const react_hook_form_1 = require("react-hook-form");
const Selectbox_1 = require("@procyon/components/Selectbox");
const enums_1 = require("@procyon/types/enums");
const utils_1 = require("@procyon/utils");
const SelectBoxField = (props) => {
    const { name, onChange, value } = props, others = __rest(props, ["name", "onChange", "value"]);
    const { control } = (0, react_hook_form_1.useFormContext)();
    const { field, fieldState: { error }, } = (0, react_hook_form_1.useController)({ name, control });
    (0, react_1.useEffect)(() => {
        if (!(0, utils_1.isNilOrEmpty)(value)) {
            field.onChange(value);
        }
    }, [value]);
    const handleChange = (0, react_1.useCallback)((option, e) => {
        if ((0, utils_1.isNilOrEmpty)(option)) {
            field.onChange(null);
            if ((0, ramda_1.is)(Function, onChange)) {
                onChange(undefined, e);
            }
        }
        else {
            field.onChange(option.code);
            if ((0, ramda_1.is)(Function, onChange)) {
                onChange(option, e);
            }
        }
    }, [field]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Selectbox_1.Selectbox, Object.assign({}, others, { name: field.name, value: field.value, onChange: handleChange }, (error ? { status: enums_1.StatusEnum.error } : {}))),
        react_1.default.createElement("div", { className: "field-validationMessage" }, error === null || error === void 0 ? void 0 : error.message)));
};
exports.SelectBoxField = SelectBoxField;
